Back to index

salome-geom  6.5.0
GEOM_TestAll.py
Go to the documentation of this file.
00001 #  -*- coding: iso-8859-1 -*-
00002 # Copyright (C) 2007-2012  CEA/DEN, EDF R&D, OPEN CASCADE
00003 #
00004 # Copyright (C) 2003-2007  OPEN CASCADE, EADS/CCR, LIP6, CEA/DEN,
00005 # CEDRAT, EDF R&D, LEG, PRINCIPIA R&D, BUREAU VERITAS
00006 #
00007 # This library is free software; you can redistribute it and/or
00008 # modify it under the terms of the GNU Lesser General Public
00009 # License as published by the Free Software Foundation; either
00010 # version 2.1 of the License.
00011 #
00012 # This library is distributed in the hope that it will be useful,
00013 # but WITHOUT ANY WARRANTY; without even the implied warranty of
00014 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
00015 # Lesser General Public License for more details.
00016 #
00017 # You should have received a copy of the GNU Lesser General Public
00018 # License along with this library; if not, write to the Free Software
00019 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
00020 #
00021 # See http://www.salome-platform.org/ or email : webmaster.salome@opencascade.com
00022 #
00023 
00024 #  GEOM GEOM_SWIG : binding of C++ omplementaion with Python
00025 #  File   : GEOM_usinggeom.py
00026 #  Author : Damien COQUERET, Open CASCADE
00027 #  Module : GEOM
00028 
00029 # ! Please, if you edit this example file, update also
00030 # ! GEOM_SRC/doc/salome/gui/GEOM/input/tui_test_all.doc
00031 # ! as some sequences of symbols from this example are used during
00032 # ! documentation generation to identify certain places of this file
00033 
00034 def TestAll (geompy, math):
00035   import GEOM
00036   
00037   #Create base Variables
00038   nbtimes1  = 5      #Short
00039   nbtimes2  = 5
00040   mindeg = 2
00041   maxdeg = 5
00042   nbiter = 5
00043   WantPlanarFace = 1 #True
00044 
00045   radius  = 10.  #Double
00046   radius1 = 100.
00047   radius2 = 200.
00048   height  = 200.
00049   d1      = 10.
00050   d2      = 10.
00051   step1   = 250.
00052   step2   = 250.
00053   angle   = 45.
00054   angle1  = angle * math.pi / 180
00055   angle2  = 2 * angle1
00056   factor  = 2.
00057   tol3d   = 0.0001
00058   tol2d   = 0.0001
00059   weight  = 1000000.
00060   waterdensity = 1.
00061   meshingdeflection = 0.01
00062   trimsize  = 1000.
00063   precision = 0.00001
00064 
00065   #Create base points
00066   p0   = geompy.MakeVertex(0.  , 0.  , 0.  ) #(3 Doubles)->GEOM_Object
00067   px   = geompy.MakeVertex(100., 0.  , 0.  )
00068   py   = geompy.MakeVertex(0.  , 100., 0.  )
00069   pz   = geompy.MakeVertex(0.  , 0.  , 100.)
00070   pxyz = geompy.MakeVertex(100., 100., 100.)
00071 
00072   p200 = geompy.MakeVertexWithRef(pxyz, 100., 100., 100.) #(GEOM_Object, 3 Doubles)->GEOM_Object
00073 
00074   #Create base directions
00075   vx   = geompy.MakeVector(p0, px) #(GEOM_Object, GEOM_Object)->GEOM_Object
00076   vy   = geompy.MakeVector(p0, py)
00077   vz   = geompy.MakeVector(p0, pz)
00078   vxy  = geompy.MakeVector(px, py)
00079 
00080   vxyz = geompy.MakeVectorDXDYDZ(100., 100., 100.) #(3 Doubles)->GEOM_Object
00081 
00082   #Create local coordinate systems
00083   cs1 = geompy.MakeMarker(50,50,50, 1,0,0, 0,1,0) #(9 Doubles)->GEOM_Object
00084   cs2 = geompy.MakeMarker(70,80,10, 1,0,1, 1,1,0) #(9 Doubles)->GEOM_Object
00085   cs3 = geompy.MakeMarkerPntTwoVec(pz, vxy, vz)   #(3 GEOM_Object)->GEOM_Object
00086 
00087   #Create base geometry 2D
00088   Line   = geompy.MakeLineTwoPnt(p0, pxyz)                  #(2 GEOM_Object)->GEOM_Object
00089   Line1  = geompy.MakeLine(pz, vxy)                         #(2 GEOM_Object)->GEOM_Object
00090   Line2  = geompy.MakeLineTwoPnt(pxyz, pz)                  #(2 GEOM_Object)->GEOM_Object
00091   Plane  = geompy.MakePlane(pz, vxyz, trimsize)             #(2 GEOM_Object, Double)->GEOM_Object
00092   Plane1 = geompy.MakePlaneThreePnt(px, pz, p200, trimsize) #(4 Doubles)->GEOM_Object
00093   Plane2 = geompy.MakePlane2Vec(vx, vz, trimsize)           #(2 GEOM_Object, Double)->GEOM_Object
00094   Plane3 = geompy.MakePlaneLCS(cs1, trimsize, 3)     #(1 GEOM_Object, 2 Double)->GEOM_Object
00095 
00096   Arc      = geompy.MakeArc(py, pz, px)                   #(3 GEOM_Object)->GEOM_Object
00097   Arc2     = geompy.MakeArcCenter(py, pz, px,0)           #(3 GEOM_Object,Boolean)->GEOM_Object
00098   Arc3     = geompy.MakeArcOfEllipse(p0, px, pz)          #(3 GEOM_Object,Boolean)->GEOM_Object
00099   Circle   = geompy.MakeCircle(p0, vz, radius1)           #(2 GEOM_Object, Double)->GEOM_Object
00100   Circle1  = geompy.MakeCircleThreePnt(p0, pxyz, px)      #(3 GEOM_Object)->GEOM_Object
00101   Circle2  = geompy.MakeCircleCenter2Pnt(p0, pxyz, py)    #(3 GEOM_Object)->GEOM_Object
00102   Ellipse  = geompy.MakeEllipse(p0, vy, radius2, radius1) #(2 GEOM_Object, 2 Doubles)->GEOM_Object
00103   Polyline = geompy.MakePolyline([p0, pz, py, p200])      #(List of GEOM_Object)->GEOM_Object
00104   Bezier   = geompy.MakeBezier([p0, pz, p200, px])        #(List of GEOM_Object)->GEOM_Object
00105   Interpol = geompy.MakeInterpol([px, py, p200, pxyz], True) #(List of GEOM_Object,Boolean)->GEOM_Object
00106   Sketcher = geompy.MakeSketcher("Sketcher:F -100 -100:TT 250 -100:R 0:C 100 150:R 0:L 300:WW",
00107                                  [100,0,0, 1,1,1, -1,1,0]) #(String, List of Doubles)->GEOM_Object
00108   Sketcher3d = geompy.Make3DSketcher([0,0,0, 50,50,50, 0,50,50, 10,0,0])
00109   
00110   #Create local coordinate system from shape
00111   cs4 = geompy.MakeMarkerFromShape(Plane)
00112 
00113   #Test point on curve creation
00114   p_on_arc = geompy.MakeVertexOnCurve(Arc, 0.25) #(GEOM_Object, Double)->GEOM_Object
00115   p_on_arc2 = geompy.MakeVertexOnCurveByCoord(Arc, 100, -10, 10 ) #(GEOM_Object, Double)->GEOM_Object
00116   p_on_arc3 = geompy.MakeVertexOnCurveByLength(Arc, 50, py) #(GEOM_Object, Double, GEOM_Object)->GEOM_Object
00117 
00118   #Test point on lines intersection
00119   p_on_l1l2 = geompy.MakeVertexOnLinesIntersection(Line1, Line2) #(2 GEOM_Object)->GEOM_Object
00120 
00121   #Test tangent on curve creation
00122   tan_on_arc = geompy.MakeTangentOnCurve(Arc, 0.7) #(GEOM_Object, Double)->GEOM_Object
00123   
00124   #Test tangent on face creation
00125   tan_vertex_1 = geompy.MakeVertex(0, 0, 0)
00126   tan_vertex_2 = geompy.MakeVertex(0, 90, 30)
00127   tan_vertex_3 = geompy.MakeVertex(100, 90, 0)
00128   tan_vertex_4 = geompy.MakeVertex(-100, 90, 0)
00129   tan_curve = geompy.MakeInterpol([tan_vertex_4, tan_vertex_2, tan_vertex_3, tan_vertex_1], False)
00130   tan_extrusion = geompy.MakePrismDXDYDZ(tan_curve, 0, 30, -60)
00131   tan_on_face = geompy.MakeTangentPlaneOnFace(tan_extrusion, 0.7, 0.5, 150)
00132 
00133   #Create base geometry 3D
00134   Box      = geompy.MakeBoxTwoPnt(p0, p200)                   #(2 GEOM_Object)->GEOM_Object
00135   Box1     = geompy.MakeBoxDXDYDZ(10, 20, 30)                 #(3 Doubles)->GEOM_Object
00136   Box2     = geompy.MakeBox(10,20,30, 15,25,35)               #(6 Doubles)->GEOM_Object
00137   Cylinder = geompy.MakeCylinder(p0, vz, radius1, height)     #(2 GEOM_Object, 2 Doubles)->GEOM_Object
00138   Cyl1     = geompy.MakeCylinderRH(radius2, height)           #(2 Doubles)->GEOM_Object
00139   Sphere   = geompy.MakeSpherePntR(p0, radius1)               #(GEOM_Object, Double)->GEOM_Object
00140   Sphere1  = geompy.MakeSphereR(radius)                       #(Double)->GEOM_Object
00141   Sphere2  = geompy.MakeSphere(50, 70, 30, radius)            #(4 Doubles)->GEOM_Object
00142   Cone     = geompy.MakeCone(p0, vz, radius2, radius, height) #(2 GEOM_Object, 3 Doubles)->GEOM_Object
00143   Cone1    = geompy.MakeConeR1R2H(radius1, radius, height)    #(3 Doubles)->GEOM_Object
00144   Torus    = geompy.MakeTorus(p0, vz, radius2, radius)        #(2 GEOM_Object, 2 Doubles)->GEOM_Object
00145   Torus1   = geompy.MakeTorusRR(radius2, radius1)             #(2 Doubles)->GEOM_Object
00146 
00147   #Boolean (Common, Cut, Fuse, Section)
00148   Common  = geompy.MakeBoolean(Box, Sphere, 1) #(2 GEOM_Object, Short)->GEOM_Object
00149   Cut     = geompy.MakeBoolean(Box, Sphere, 2)
00150   Fuse    = geompy.MakeBoolean(Box, Sphere, 3)
00151   Section = geompy.MakeBoolean(Box, Sphere, 4)
00152 
00153   #Create base objects
00154   Edge     = geompy.MakeEdge(p0, pxyz)               #(2 GEOM_Object)->GEOM_Object
00155   Edge1    = geompy.MakeEdgeOnCurveByLength(Arc, 50, px) #(GEOM_Object, Double, GEOM_Object)->GEOM_Object
00156   Wire     = geompy.MakeWire([vxy, Arc])             #(List Of GEOM_Object)->GEOM_Object
00157   Face     = geompy.MakeFace(Wire, WantPlanarFace)   #(GEOM_Object, Boolean)->GEOM_Object
00158   Face1    = geompy.MakeFaceWires([Wire, Sketcher],
00159                                   WantPlanarFace)    #(List of GEOM_Object, Boolean)->GEOM_Object
00160   Face2    = geompy.MakeFace(Sketcher, WantPlanarFace)
00161   Face3    = geompy.MakeFaceHW (100., 200., 1)       #(2 Doubles, 1 Int)->GEOM_Object
00162   Face4    = geompy.MakeFaceObjHW (vz, 200., 100.)   #(1 GEOM_Object, 2 Doubles)->GEOM_Object
00163   Disk     = geompy.MakeDiskPntVecR (p0, vz, radius) #(2 GEOM_Object, 1 Double)->GEOM_Object
00164   Disk2    = geompy.MakeDiskThreePnt(p0, p200, pz)   #(3 GEOM_Object)->GEOM_Object
00165   Disk3    = geompy.MakeDiskR(100., 1)               #(1 Doubles, 1 Int)->GEOM_Object
00166   Shell    = geompy.MakeShell([Face, Face1])         #(List of GEOM_Object)->GEOM_Object
00167 
00168   Prism1   = geompy.MakePrism(Face2, p0, pxyz)       #(3 GEOM_Object)->GEOM_Object
00169   prism1_faces = geompy.SubShapeAllSortedCentres(Prism1, geompy.ShapeType["FACE"])
00170   Shell1   = geompy.MakeShell([prism1_faces[0], prism1_faces[1],
00171                                prism1_faces[3], prism1_faces[4],
00172                                prism1_faces[5], prism1_faces[2]])
00173   Solid    = geompy.MakeSolid([Shell1])              #(List of GEOM_Object)->GEOM_Object
00174 
00175   ShapeListCompound = []
00176   i = 0
00177   while i <= 3 :
00178         S = geompy.MakeTranslation(Arc, i * 100., i * 100., i * 100.)
00179         ShapeListCompound.append(S)
00180         i = i + 1
00181   Compound = geompy.MakeCompound(ShapeListCompound)  #(List of GEOM_Object)->GEOM_Object
00182 
00183   #Test point on surface creation
00184   p_on_face = geompy.MakeVertexOnSurface(Face, 0.1, 0.8) #(GEOM_Object, Double, Double)->GEOM_Object
00185   p_on_face2 = geompy.MakeVertexOnSurfaceByCoord(Face, 0., 0., 0.) #(GEOM_Object, Double, Double, Double)->GEOM_Object
00186 
00187   # Test plane from existing face creation
00188   Plane2 = geompy.MakePlaneFace(Face, trimsize)      #(GEOM_Object, Double)->GEOM_Object
00189 
00190   #ShapeList for Sewing
00191   S = geompy.MakeRotation(Face, vxy, angle1)
00192 
00193   #Test Line on Faces Intersection
00194   Line3 = geompy.MakeLineTwoFaces(prism1_faces[0], prism1_faces[1]) #(2 GEOM_Object)->GEOM_Object
00195 
00196   #Create advanced objects
00197   Copy       = geompy.MakeCopy(Box)                      #(GEOM_Object)->GEOM_Object
00198   Prism            = geompy.MakePrismVecH(Face, vz, 100.0)     #(2 GEOM_Object, Double)->GEOM_Object
00199   Prism2Ways       = geompy.MakePrismVecH2Ways(Face, vz, 10.0) #(2 GEOM_Object, Double)->GEOM_Object
00200   PrismTwoPnt      = geompy.MakePrism(Face2, p0, pxyz)         #(3 GEOM_Object)->GEOM_Object
00201   PrismTwoPnt2Ways = geompy.MakePrism2Ways(Face2, p0, pxyz)    #(3 GEOM_Object)->GEOM_Object
00202   PrismDXDYDZ      = geompy.MakePrismDXDYDZ(Face2, 10, 20, 100)#(2 GEOM_Object, Double)->GEOM_Object
00203   PrismDXDYDZ2Ways = geompy.MakePrismDXDYDZ2Ways(Face, 30, -20, 200)#(2 GEOM_Object, Double)->GEOM_Object
00204   Revolution       = geompy.MakeRevolution(Face, vz, angle2)   #
00205   Revolution2Ways  = geompy.MakeRevolution(Face, vz, angle1)   #
00206   Filling          = geompy.MakeFilling(Compound, mindeg, maxdeg,
00207                                   tol2d, tol3d, nbiter)  #(GEOM_Object, 4 Doubles, Short)->GEOM_Object
00208   Pipe       = geompy.MakePipe(Wire, Edge)               #(2 GEOM_Object)->GEOM_Object
00209   Sewing     = geompy.MakeSewing([Face, S], precision)   #(List Of GEOM_Object, Double)->GEOM_Object
00210 
00211   #Transform objects
00212   Translation = geompy.MakeTranslationTwoPoints(Box, px, pz)    #(3 GEOM_Object)->GEOM_Object
00213   TranslVect  = geompy.MakeTranslationVector(Box, vxyz)         #(2 GEOM_Object)->GEOM_Object
00214   TranslVectD = geompy.MakeTranslationVectorDistance(Box, vxyz, 50.0)   #(2 GEOM_Object)->GEOM_Object  
00215   Rotation    = geompy.MakeRotation(Box, vz, angle1)            #(2 GEOM_Object, Double)->GEOM_Object
00216   RotatPnt    = geompy.MakeRotationThreePoints(Box, px, py, pz) #(4 GEOM_Object)->GEOM_Object
00217 
00218   #Scale by factor relatively given point
00219   Scale1 = geompy.MakeScaleTransform(Box, pxyz, factor)      #(2 GEOM_Object, Double)->GEOM_Object
00220   #Scale by factor relatively the origin of global CS
00221   Scale2 = geompy.MakeScaleTransform(Box, None, factor)      #
00222   #Scale along axes of global CS by different factors. Scale relatively given point
00223   Scale3 = geompy.MakeScaleAlongAxes(Box, pxyz, 1.5, 0.5, 3) #(2 GEOM_Object, 3 Doubles)->GEOM_Object
00224   #Scale along axes of global CS by different factors. Scale relatively the origin of global CS
00225   Scale4 = geompy.MakeScaleAlongAxes(Box, None, 1.5, 0.5, 3) #
00226 
00227   Mirror      = geompy.MakeMirrorByPlane(Box, Plane) #(2 GEOM_Object)->GEOM_Object
00228   MirrorAxis  = geompy.MakeMirrorByAxis(Box, Line1)  #
00229   MirrorPnt   = geompy.MakeMirrorByPoint(Box, p200)  #
00230   Position    = geompy.MakePosition(Box, cs1, cs2)   #(3 GEOM_Object)->GEOM_Object
00231   Position2   = geompy.PositionAlongPath(Box, Arc, 0.5, 1, 0)  #(2 GEOM_Object, 1 Double, 2 Bool)->GEOM_Object
00232   Offset      = geompy.MakeOffset(Box, 10.)          #(GEOM_Object, Double)->GEOM_Object
00233   Orientation = geompy.ChangeOrientation(Box)
00234 
00235   #IDList for Fillet/Chamfer
00236   prism_edges = geompy.ExtractShapes(Prism, geompy.ShapeType["EDGE"], True)
00237 
00238   for anEdge in prism_edges:
00239     eid = geompy.GetSubShapeID(Prism, anEdge)
00240     sse = geompy.GetSubShape(Prism, [eid])
00241 
00242     sse_id = geompy.GetSubShapeID(Prism, sse)
00243     if sse_id != eid:
00244       print "Error: GetSubShape() or GetSubShapeID() has failed!"
00245 
00246   IDlist_e = []
00247   IDlist_e.append(geompy.GetSubShapeID(Prism, prism_edges[0]))
00248   IDlist_e.append(geompy.GetSubShapeID(Prism, prism_edges[1]))
00249   IDlist_e.append(geompy.GetSubShapeID(Prism, prism_edges[2]))
00250 
00251   prism_faces = geompy.ExtractShapes(Prism, geompy.ShapeType["FACE"], True)
00252 
00253   f_ind_1 = geompy.GetSubShapeID(Prism, prism_faces[0])
00254   f_ind_2 = geompy.GetSubShapeID(Prism, prism_faces[1])
00255 
00256   IDlist_f = [f_ind_1, f_ind_2]
00257   
00258   #Local operations
00259   Fillet2d = geompy.MakeFillet2D(Face3, radius, [4, 7, 9]) #(GEOM_Object, Double, ListOfLong)->GEOM_Object
00260   Fillet   = geompy.MakeFillet (Prism, radius, geompy.ShapeType["EDGE"],
00261                                 IDlist_e) #(GEOM_Object, Double, Short, ListOfLong)->GEOM_Object
00262   Fillet2  = geompy.MakeFilletR1R2 (Prism, 7., 13., geompy.ShapeType["EDGE"],
00263                                     IDlist_e) #(GEOM_Object, Double, Double, Short, ListOfLong)->GEOM_Object
00264   Chamfer  = geompy.MakeChamferEdge(Prism, d1, d2,
00265                                     f_ind_1, f_ind_2) #(GEOM_Object, 2 Doubles, 2 Long)->GEOM_Object
00266   Chamfer2 = geompy.MakeChamferFaces(Prism, d1, d2,
00267                                      IDlist_f) #(GEOM_Object, 2 Doubles, ListOfLong)->GEOM_Object
00268   Chamfer3 = geompy.MakeChamferEdges(Prism, d1, d2,
00269                                      IDlist_e) #(GEOM_Object, 2 Doubles, ListOfLong)->GEOM_Object
00270   Chamfer4 = geompy.MakeChamferFacesAD(Prism, d1, 20. * math.pi / 180.,
00271                                        IDlist_f) #(GEOM_Object, 2 Doubles, ListOfLong)->GEOM_Object
00272   #End of Local operations
00273 
00274   #Create Patterns
00275   MultiTrans1D = geompy.MakeMultiTranslation1D(Fillet, vz, step1, nbtimes1)
00276   MultiTrans2D = geompy.MakeMultiTranslation2D(Fillet, vz, step1, nbtimes1, vy, step2, nbtimes2)
00277   #!!!!Angle In Degree!!!!
00278   MultiRot1D   = geompy.MultiRotate1D(Chamfer, vx, nbtimes1)
00279   MultiRot2D   = geompy.MultiRotate2D(Chamfer, vx, angle, nbtimes1, step1, nbtimes2)
00280 
00281   #Create Informations objects
00282   CDG        = geompy.MakeCDG(Prism)               #(GEOM_Object)->GEOM_Object
00283   Archimede  = geompy.Archimede(Box, weight, waterdensity,
00284                                 meshingdeflection) #(GEOM_Object, 3 Doubles)->GEOM_Object
00285   mindist = geompy.MinDistanceComponents(TranslVect, Mirror) #(2 GEOM_Object)->4 Doubles
00286   print "Minumal distance between TranslVect and Mirror is", mindist[0],
00287   print "by components:", mindist[1], ",", mindist[2], ",", mindist[3]
00288   CheckShape = geompy.CheckShape(Prism)            #(GEOM_Object)->Boolean
00289   print "CheckShape(Prism) = ", CheckShape
00290 
00291   #Partition objects
00292   Partition  = geompy.MakePartition([Box], [Plane]) #(2 Lists Of GEOM_Object)->GEOM_Object
00293   Partition1 = geompy.MakeHalfPartition(Box, Plane) #(2 GEOM_Object)->GEOM_Object
00294 
00295   #Add In Study
00296   id_p0   = geompy.addToStudy(p0,   "Vertex 0")
00297   id_px   = geompy.addToStudy(px,   "Vertex X")
00298   id_py   = geompy.addToStudy(py,   "Vertex Y")
00299   id_pz   = geompy.addToStudy(pz,   "Vertex Z")
00300   id_pxyz = geompy.addToStudy(pxyz, "Vertex XYZ")
00301   id_p200 = geompy.addToStudy(p200, "Vertex 200")
00302 
00303   id_vx   = geompy.addToStudy(vx,   "Vector X")
00304   id_vy   = geompy.addToStudy(vy,   "Vector Y")
00305   id_vz   = geompy.addToStudy(vz,   "Vector Z")
00306   id_vxy  = geompy.addToStudy(vxy,  "Vector XY")
00307   id_vxyz = geompy.addToStudy(vxyz, "Vector XYZ")
00308 
00309   id_cs1 = geompy.addToStudy(cs1, "CS 50,50,50, 1,0,0, 0,1,0")
00310   id_cs2 = geompy.addToStudy(cs2, "CS 70,80,10, 1,0,1, 1,1,0")
00311   id_cs3 = geompy.addToStudy(cs3, "CS: pz, vxy, vz")
00312   id_cs4 = geompy.addToStudy(cs4, "CS: Plane")
00313 
00314   id_Line   = geompy.addToStudy(Line,   "Line")
00315   id_Line1  = geompy.addToStudy(Line1,  "Line by point and vector")
00316   id_Line3  = geompy.addToStudy(Line3,  "Line on Two Faces Intersection")
00317   id_Plane  = geompy.addToStudy(Plane,  "Plane")
00318   id_Plane1 = geompy.addToStudy(Plane1,  "Plane by 3 points")
00319   id_Plane2 = geompy.addToStudy(Plane2,  "Plane by 2 vectors")
00320   id_Plane3 = geompy.addToStudy(Plane3,  "Plane by LCS")
00321 
00322   id_Arc      = geompy.addToStudy(Arc,      "Arc")
00323   id_Arc2     = geompy.addToStudy(Arc2,     "Arc2")
00324   id_Arc3     = geompy.addToStudy(Arc3,     "Arc3")
00325   id_Circle   = geompy.addToStudy(Circle,   "Circle")
00326   id_Circle1  = geompy.addToStudy(Circle1,  "Circle by 3 points")
00327   id_Circle2  = geompy.addToStudy(Circle2,  "Circle by center and 2 points")
00328   id_Ellipse  = geompy.addToStudy(Ellipse,  "Ellipse")
00329   id_Polyline = geompy.addToStudy(Polyline, "Polyline")
00330   id_Bezier   = geompy.addToStudy(Bezier,   "Bezier")
00331   id_Interpol = geompy.addToStudy(Interpol, "Interpol")
00332   id_Sketcher = geompy.addToStudy(Sketcher, "Sketcher")
00333   id_Sketcher3d = geompy.addToStudy(Sketcher3d, "Sketcher 3D")
00334 
00335   id_p_on_arc  = geompy.addToStudy(p_on_arc,  "Vertex on Arc (0.25)")
00336   id_p_on_arc2 = geompy.addToStudy(p_on_arc2, "Vertex on Arc at(100, -10, 10)" )
00337   id_p_on_arc3 = geompy.addToStudy(p_on_arc3, "Vertex on Arc length 50 from Vertex X" )
00338   
00339   id_p_on_l1l2 = geompy.addToStudy(p_on_l1l2, "Vertex on Lines Intersection")
00340 
00341   id_tan_on_arc  = geompy.addToStudy(tan_on_arc, "Tangent on Arc (0.7)")
00342   id_tan_on_face = geompy.addToStudy(tan_on_face, "Tangent on Face")
00343 
00344   id_Box      = geompy.addToStudy(Box,      "Box")
00345   id_Box1     = geompy.addToStudy(Box1,     "Box 10x20x30")
00346   id_Box2     = geompy.addToStudy(Box2,     "Box (10,20,30)-(15,25,35)")
00347   id_Cylinder = geompy.addToStudy(Cylinder, "Cylinder")
00348   id_Cyl1     = geompy.addToStudy(Cyl1,     "Cylinder RH")
00349   id_Sphere   = geompy.addToStudy(Sphere,   "Sphere Pnt R")
00350   id_Sphere1  = geompy.addToStudy(Sphere1,  "Sphere R")
00351   id_Sphere2  = geompy.addToStudy(Sphere2,  "Sphere")
00352   id_Cone     = geompy.addToStudy(Cone,     "Cone")
00353   id_Cone1    = geompy.addToStudy(Cone1,    "Cone R1R2H")
00354   id_Torus    = geompy.addToStudy(Torus,    "Torus")
00355   id_Torus1   = geompy.addToStudy(Torus1,   "Torus RR")
00356 
00357   id_Common  = geompy.addToStudy(Common,  "Common")
00358   id_Cut     = geompy.addToStudy(Cut,     "Cut")
00359   id_Fuse    = geompy.addToStudy(Fuse,    "Fuse")
00360   id_Section = geompy.addToStudy(Section, "Section")
00361 
00362   id_Edge     = geompy.addToStudy(Edge,     "Edge")
00363   id_Edge1    = geompy.addToStudy(Edge1,    "Edge on Arc length 50 from Vertex Y")
00364   id_Wire     = geompy.addToStudy(Wire,     "Wire")
00365   id_Face     = geompy.addToStudy(Face,     "Face")
00366   id_Face1    = geompy.addToStudy(Face1,    "Face from two wires")
00367   id_Face2    = geompy.addToStudy(Face2,    "Face from Sketcher")
00368   id_Face3    = geompy.addToStudy(Face3,    "Face Height Width")
00369   id_Face4    = geompy.addToStudy(Face4,    "Face Plane_HW")
00370   id_Disk     = geompy.addToStudy(Disk,     "Disk PntVecR")
00371   id_Disk2    = geompy.addToStudy(Disk2,    "Disk Three Points")
00372   id_Disk3    = geompy.addToStudy(Disk3,    "Disk OXY Radius")
00373   id_Shell    = geompy.addToStudy(Shell,    "Shell")
00374 
00375   id_p_on_face = geompy.addToStudy(p_on_face, "Vertex on Face (0.1, 0.8)")
00376   id_p_on_face2 = geompy.addToStudy(p_on_face2, "Vertex on Face at(0., 0., 0.)")
00377 
00378   id_Prism1   = geompy.addToStudy(Prism1,     "Prism by Two Pnt")
00379   id_Shell1   = geompy.addToStudy(Shell1,   "Shell from Prism1 faces")
00380   id_Solid    = geompy.addToStudy(Solid,    "Solid")
00381   id_Compound = geompy.addToStudy(Compound, "Compound")
00382 
00383   id_Plane2   = geompy.addToStudy(Plane2,   "Plane on Face")
00384 
00385   id_Copy       = geompy.addToStudy(Copy,       "Copy")
00386   id_Prism            = geompy.addToStudy(Prism,            "Prism")
00387   id_Prism2Ways       = geompy.addToStudy(Prism2Ways,       "Prism2Ways")
00388   id_PrismTwoPnt      = geompy.addToStudy(PrismTwoPnt,      "PrismTwoPnt")
00389   id_PrismTwoPnt2Ways = geompy.addToStudy(PrismTwoPnt2Ways, "PrismTwoPnt2Ways")
00390   id_PrismDXDYDZ      = geompy.addToStudy(PrismDXDYDZ,      "PrismDXDYDZ")
00391   id_PrismDXDYDZ2Ways = geompy.addToStudy(PrismDXDYDZ2Ways, "PrismDXDYDZ2Ways")
00392   id_Revolution       = geompy.addToStudy(Revolution,       "Revolution")
00393   id_Revolution2Ways  = geompy.addToStudy(Revolution2Ways,  "Revolution2Ways")
00394   id_Filling    = geompy.addToStudy(Filling,    "Filling")
00395   id_Pipe       = geompy.addToStudy(Pipe,       "Pipe")
00396   id_Sewing     = geompy.addToStudy(Sewing,     "Sewing")
00397 
00398   id_Translation = geompy.addToStudy(Translation, "Translation")
00399   id_TranslVect  = geompy.addToStudy(TranslVect , "Translation along vector")
00400   id_TranslVectD = geompy.addToStudy(TranslVectD, "Translation along vector with defined distance")
00401   id_Rotation    = geompy.addToStudy(Rotation,    "Rotation")
00402   id_RotatPnt    = geompy.addToStudy(RotatPnt,    "Rotation by three points")
00403   id_Scale1      = geompy.addToStudy(Scale1,      "Scale1")
00404   id_Scale2      = geompy.addToStudy(Scale2,      "Scale2")
00405   id_Scale3      = geompy.addToStudy(Scale3,      "Scale3")
00406   id_Scale4      = geompy.addToStudy(Scale4,      "Scale4")
00407   id_Mirror      = geompy.addToStudy(Mirror,      "Mirror by Plane")
00408   id_MirrorAxis  = geompy.addToStudy(MirrorAxis,  "Mirror by Axis")
00409   id_MirrorPnt   = geompy.addToStudy(MirrorPnt,   "Mirror by Point")
00410   id_Position    = geompy.addToStudy(Position,    "Positioned box")
00411   id_Position2   = geompy.addToStudy(Position2,   "Positioned box along path")
00412   id_Offset      = geompy.addToStudy(Offset,      "Offset")
00413   id_Orientation = geompy.addToStudy(Orientation, "Orientation")
00414 
00415   id_Fillet   = geompy.addToStudy(Fillet,   "Fillet")
00416   id_Fillet2  = geompy.addToStudy(Fillet2,  "Fillet2")
00417   id_Fillet2d = geompy.addToStudy(Fillet2d, "Fillet2D")
00418 
00419   id_Chamfer  = geompy.addToStudy(Chamfer,  "Chamfer on Edge")
00420   id_Chamfer2 = geompy.addToStudy(Chamfer2, "Chamfer on Faces")
00421   id_Chamfer3 = geompy.addToStudy(Chamfer3, "Chamfer on Edges")
00422   id_Chamfer4 = geompy.addToStudy(Chamfer4, "Chamfer on Faces with params D Angle")
00423 
00424   id_MultiTrans1D = geompy.addToStudy(MultiTrans1D, "MultiTrans1D")
00425   id_MultiTrans2D = geompy.addToStudy(MultiTrans2D, "MultiTrans2D")
00426   id_MultiRot1D   = geompy.addToStudy(MultiRot1D,   "MultiRot1D")
00427   id_MultiRot2D   = geompy.addToStudy(MultiRot2D,   "MultiRot2D")
00428 
00429   id_CDG       = geompy.addToStudy(CDG,       "CDG")
00430   id_Archimede = geompy.addToStudy(Archimede, "Archimede")
00431 
00432   id_Partition  = geompy.addToStudy(Partition, "Partition")
00433   id_Partition1 = geompy.addToStudy(Partition1, "Half Partition")
00434 
00435   #Decompose objects
00436 
00437   # SubShape
00438   SubFace    = geompy.SubShape(Box, geompy.ShapeType["FACE"], [2])
00439   name       = geompy.SubShapeName(SubFace, Box)
00440   id_SubFace = geompy.addToStudyInFather(Box, SubFace, name)
00441 
00442   # SubShapeSortedCentres
00443   SubFaceS   = geompy.SubShapeSortedCentres(Box, geompy.ShapeType["FACE"], [5])
00444   nameS      = geompy.SubShapeName(SubFaceS, Box)
00445   id_SubFace = geompy.addToStudyInFather(Box, SubFaceS, nameS)
00446 
00447   # GetExistingSubObjects
00448   SubObjsAll = geompy.GetExistingSubObjects(Box, True)
00449   print "For now, Box has the following created sub-objects:", SubObjsAll
00450 
00451   # GetGroups
00452   SubGrpsAll = geompy.GetGroups(Box)
00453   print "For now, Box has the following created groups:", SubGrpsAll
00454 
00455   # SubShapeAll
00456   SubEdgeList = geompy.SubShapeAll(SubFace, geompy.ShapeType["EDGE"])
00457   i=0
00458   for SubEdge in SubEdgeList :
00459     name = geompy.SubShapeName(SubEdge, SubFace)
00460     id_SubEdge = geompy.addToStudyInFather(SubFace, SubEdge, name)
00461 
00462   # SubShapeAllIDs
00463   SubEdgeIDsList = geompy.SubShapeAllIDs(SubFace, geompy.ShapeType["EDGE"])
00464   print "IDs of edges of SubFace:", SubEdgeIDsList, "(unsorted)"
00465   group = geompy.CreateGroup(SubFace, geompy.ShapeType["EDGE"])
00466   geompy.UnionIDs(group, SubEdgeIDsList)
00467   geompy.addToStudyInFather(SubFace, group, "Group of all edges")
00468 
00469   # SubShapeAllSortedCentresIDs
00470   SubEdgeIDsList = geompy.SubShapeAllSortedCentresIDs(SubFace, geompy.ShapeType["EDGE"])
00471   print "IDs of edges of SubFace:", SubEdgeIDsList, "(sorted)"
00472 
00473   # GetSubShape and GetSubShapeID
00474   for ind in SubEdgeIDsList:
00475     edge = geompy.GetSubShape(SubFace, [ind])
00476     ind_e = geompy.GetSubShapeID(SubFace, edge)
00477     if ind_e != ind:
00478       print "Error in GetSubShape or GetSubShapeID"
00479 
00480   # RestoreSubShapes
00481   geompy.RestoreSubShapes(Copy)
00482   geompy.RestoreSubShapes(RotatPnt, [], GEOM.FSM_Transformed)
00483   geompy.RestoreSubShapes(Partition, [Box])
00484   geompy.RestoreSubShapes(Partition1)
00485 
00486   print "DONE"